#include <esp_now.h>
#include <WiFi.h>
#include "oled.h"

// OLED display = OLED(21, 22, NO_RESET_PIN, 0x3C, 128, 64, false); // SSD1306
OLED display = OLED(21, 22, NO_RESET_PIN, 0x3C, 128, 64, true); // SH1106

typedef struct {
  char  myname[8];
  float temperature;
  float humidity;
  float pressure;
} struct_message;

struct_message message;
static char msg[30];      // character buffer

void data_receive(const uint8_t * mac, const uint8_t *incomingData, int len) {
  int x = 0;
  memcpy(&message, incomingData, sizeof(message));
  if (message.myname[0] == 'B') {
    x = 0;
  } else {
    x = 64;
  }
  display.draw_rectangle(x, 0, x+63, 63, OLED::SOLID, OLED::BLACK); // Clear one half of display
  display.printf(x + 2, 0, "%s", message.myname);
  display.printf(x + 2, 10, "%.1f°C", message.temperature);
  display.printf(x + 2, 20, "%.1f %%", message.humidity);
  display.printf(x + 2, 30, "%.0f hPa", message.pressure);
  display.display();
}

void setup() {
  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }
  esp_now_register_recv_cb(data_receive);
  display.begin();
  display.clear();
  display.display();
}

void loop() {

}
